﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Note: Set HierarchyForm.trvHierarchy.Modifiers
// to Public at design time.

namespace howto_control_hierarchy
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Show the form's control hierarchy in a TreeView control.
        private void btnShowHierarchy_Click(object sender, EventArgs e)
        {
            // Make the root node.
            HierarchyForm dlg = new HierarchyForm();
            TreeView trv = dlg.trvHierarchy;
            TreeNode root = trv.Nodes.Add(ControlName(this));

            // Build the rest of the hierarchy.
            BuildHierarchy(root, this);
            trv.ExpandAll();

            // Display the hierarchy.
            dlg.ShowDialog();
        }

        // Show the ctl control's hierarchy.
        private void BuildHierarchy(TreeNode parent_node, Control parent)
        {
            foreach (Control child in parent.Controls)
            {
                TreeNode child_node =
                    parent_node.Nodes.Add(ControlName(child));
                BuildHierarchy(child_node, child);
            }
        }

        // Return the control's name and type.
        private string ControlName(Control ctl)
        {
            return ctl.Name + " [" + ctl.GetType().Name + "]";
        }
    }
}
